#pragma once

#include "pico/flash.h"

const uint16_t MAGIC_NUMBER = 3;

enum class Mode : uint8_t { IambicA = 0, IambicB, Straight };

struct Settings {
    uint16_t magic_number {MAGIC_NUMBER};   // Bytes:  2
    Mode mode {Mode::IambicB};              // Bytes:  1
    uint8_t wpm {0};                        // Bytes:  1
    uint8_t wpmPotiMin {5};                 // Bytes:  1
    uint8_t wpmPotiMax {55};                // Bytes:  1
    uint8_t dummy[FLASH_PAGE_SIZE - 6] {0}; // Sum  :  6
};

void store_settings(Settings &settings);
Settings read_settings();